import pathlib


class NotebookContext:

    def __init__(self, name=None, out_dir="../_out"):
        self.name = name
        self.out_dir = out_dir

    def file(self, filename, folder=None, name=None):
        return notebook_path(
            filename, folder=folder, notebook_name=self.name if name is None else name, out_dir=self.out_dir)

    def folder(self, folder, name=None):
        return notebook_path(
            folder=folder, notebook_name=self.name if name is None else name, out_dir=self.out_dir)


def notebook_path(filename=None, folder=None, notebook_name=None, out_dir="../../_out"):

    p = pathlib.Path(out_dir)

    if notebook_name is not None:
        p /= notebook_name

    if folder is not None:
        p /= folder

    if not p.exists():
        p.mkdir(parents=True)

    if filename is not None:
        p /= filename

    return p